
			      SAPI scanner driver
				   SAPI.EXE
				October 14, 1992

The SAPI scanner driver is a revision 6.10 scanner driver (see REV6.DOC for
more information) providing black and white, gray scale and color scanning
for the current products.

The SAPI scanner driver requires the presence of a manufacturer
supplied scanner driver (referred to in this document as SAPI.SYS since the
actual name varies from manufacturer to manufacturer. For example,
Logitech's SAPI driver is called HHSCAND.SYS). SAPI.SYS should be
loaded before the driver.

SAPI.EXE also REQUIRES that the scanner hardware be set up for interrupts.
This has NOT been the case for previous scanner drivers.

The commands provided by the SAPI scanner driver are listed below in the
example of the /H parameter.

	Valid commands:

	/Bxxx  = interrupt Buffer size in K (default is 8K, max 63K)
	/Cx    = application Code (1-4)
	/H     = display this Help text
	/?     = display this help text
	/Tx    = do diagnostic Testing (verify communication with scanner)
	/V     = Verbose messages and status displays
	/U     = Unload driver
	/N<dev>= Name of manufacturer's device driver
	/Wx    = Watchdog timeout in seconds
	/0     = Filters (manufacturer specific)
	/1     = Light Sources (manufacturer specific)

/N
==

The SAPI driver requires a "helper" driver supplied by the scanner
manufacturer. Normally, this device driver is named "HH$SCAN" (not to be
confused with the DOS file name of something like "SPECTRA.SYS")  The SAPI
3.1 specification allows for multiple device drivers under sequential names,
such as "HH$SCAN1" or "HH$SCAN2"  The /N command allows the user to specify
the device driver name to look for.


/W
==

If a watchdog timer is desired to prevent the SAPI driver from locking up
the system in case of a hardware failure, the /W command can be used.  The
default value is 0 - no timer is used.	The timer values can range from 1 to
255 seconds.


/0 /1
=====

The SAPI 3.1 specification defines some controls that are manufacturer
specific, namely filters and light sources. The /0 and /1 parameters allow
the user to set the text used in the application's scanner-defined user
interface for these controls. The syntax for /0 and /1 is:

	/0String_1,String_2[,String_3...]

Note that the comma is used to separate the items. Spaces are not allowed.
If you want a space, use an underscore (_) character. If the /0 and /1
parameters are not used, the default text will be sequential numbers starting
with 1.

For example, the Niscan Spectra scanner implements the light sources control.
The names of the controls are "Reflective" and "Transparency."  Using the
parameter "/1Reflective,Transparency" sets the text for the Light Sources
options in the application user interface.

Under some graphical user interfaces, such as Microsoft Windows, keyboard
shortcuts or accelerators are used to allow the user to quickly navigate
through a dialog box or menu structure. Keyboard shortcuts can be defined
in the /0 and /1 parameters by preceding the accelerator character with an
ampersand (&) character. The accelerators A, H, F, L, S, and U are reserved
by the SAPI driver and should not be used. Depending on the application,
the choices for filters or light sources may be implemented as a list box.
In this case, the accelerators are not used.


Manufacturer Notes
==================

At this time only the Intel Satisfaxtion, Logitech ScanMan, ScanMan+,
ScanMan 256, Niscan/GS, and Niscan Spectra have been tested with the SAPI.EXE
scanner driver. Any black and white, gray scale, or color scanner that is
compliant with the SAPI specification should work with this driver.

The following sections discuss the operaion of the SAPI driver in conbination
with the various supported scanners. Please note that all of the features
listed may not be supported by your application. For example, only the first
four or six resolutions may be available in some applications.

INTEL SATISFAXTION
------------------
This configuration supports the following features:

	FEATURE 	DRIVER SUPPORT
======================= ===============
Brightness Settings	Set on scanner
Contrast Settings	N/A
Automatic Brightness	No
Automatic Contrast	No
Resolutions		400x400, 300x300, 200x200, 100x100
Scan Modes		B/W, GS16, GS64, GS256
Halftones		Set on scanner
Enhancements		None
Maximum Scan Area	4.0" x 50.00"
Custom Settings 	None

Due to the lack of software control over the Logitech and Intel
Satisfaxtion scanners, the SAPI driver can sometimes return invalid
data for a scan. In order to avoid this problem, be sure that the
switch settings on the hand scanner are set to match the selections
made in the application. For these scanners, be sure that the mode
switch is set to 256 BEFORE SAPI.EXE is loaded or gray scale may
not be available as an option within the application.


LOGITECH SCANMAN
----------------
This configuration supports the following features:

	FEATURE 	DRIVER SUPPORT
======================= ===============
Brightness Settings	Set on scanner
Contrast Settings	N/A
Automatic Brightness	No
Automatic Contrast	No
Resolutions		400x400, 300x300, 200x200, 100x100
Scan Modes		B/W
Halftones		Set on Scanner
Enhancements		None
Maximum Scan Area	2.5" x 50.00"
Custom Settings 	None

Due to the lack of software control over the Logitech and Intel
Satisfaxtion scanners, the SAPI driver can sometimes return invalid
data for a scan. In order to avoid this problem, be sure that the
switch settings on the hand scanner are set to match the selections
made in the application. For these scanners, be sure that the mode
switch is set to 256 BEFORE SAPI.EXE is loaded or gray scale may
not be available as an option within the application.


LOGITECH SCANMAN PLUS / SCANMAN 32
----------------------------------
This configuration supports the following features:

	FEATURE 	DRIVER SUPPORT
======================= ===============
Brightness Settings	Set on scanner
Contrast Settings	N/A
Automatic Brightness	No
Automatic Contrast	No
Resolutions		400x400, 300x300, 200x200, 100x100
Scan Modes		B/W
Halftones		Set on Scanner
Enhancements		None
Maximum Scan Area	4.0" x 50.00"
Custom Settings 	None

Due to the lack of software control over the Logitech and Intel
Satisfaxtion scanners, the SAPI driver can sometimes return invalid
data for a scan. In order to avoid this problem, be sure that the
switch settings on the hand scanner are set to match the selections
made in the application. For these scanners, be sure that the mode
switch is set to 256 BEFORE SAPI.EXE is loaded or gray scale may
not be available as an option within the application.


LOGITECH SCANMAN 256
--------------------
This configuration supports the following features:

	FEATURE 	DRIVER SUPPORT
======================= ===============
Brightness Settings	Set on scanner
Contrast Settings	N/A
Automatic Brightness	No
Automatic Contrast	No
Resolutions		400x400, 300x300, 200x200, 100x100
Scan Modes		B/W, GS16, GS64, GS256
Halftones		Set on Scanner
Enhancements		None
Maximum Scan Area	4.0" x 50.00"
Custom Settings 	None

Due to the lack of software control over the Logitech and Intel
Satisfaxtion scanners, the SAPI driver can sometimes return invalid
data for a scan. In order to avoid this problem, be sure that the
switch settings on the hand scanner are set to match the selections
made in the application. For these scanners, be sure that the mode
switch is set to 256 BEFORE SAPI.EXE is loaded or gray scale may
not be available as an option within the application.


NISCAN/GS
---------
This configuration supports the following features:

	FEATURE 	DRIVER SUPPORT
======================= ===============
Brightness Settings	1 to 32
Contrast Settings	1 to 32
Automatic Brightness	No
Automatic Contrast	No
Resolutions		100x100, 200x200, 300x300, 400x400, 50x50, 150x150,
			250x250, 350x350, 25x25, 125x125, 225x225, 325x325,
			75x75, 175x175, 275x275, 375x375,
			Custom [25..400 by 25, Independent]
Scan Modes		B/W, B/W Dither, GS16, GS256
Halftones		Bayer, Coarse Fatting, Fine Fatting, Horizontal Line,
			Vertical Line, Mesh
Enhancements		None
Maximum Scan Area	4.16" x 11.00"
Custom Settings 	None


NISCAN SPECTRA
--------------
When using SAPI.EXE with the Niscan Spectra driver SPECTRA.SYS, include the
following command:
	/1&Reflective,&Transparency

This configuration supports the following features:

	FEATURE 	DRIVER SUPPORT
======================= ===============
Brightness Settings	1 to 7
Contrast Settings	1
Automatic Brightness	Yes
Automatic Contrast	No
Resolutions		50x50, 100x100, 200x200, 400x400, 75x75, 125x125,
			150x150, 175x175, 225x225, 250x250, 275x275, 300x300,
			325x325, 350x350, 375x375,
			Custom [50..400 by 25, Independent]
Scan Modes		B/W, B/W Dither, GS4, GS16, GS64, GS256, Color 24-bit
Halftones		Bayer, Coarse Fatting, Fine Fatting
Enhancements		None
Maximum Scan Area	3.96" x 5.96"
Custom Settings 	Hue [0..4]
			Light Sources [Reflective, Transparency]
NOTE: Not all applications support Custom Settings.



SAPI Messages
=============

	Supporting: ???????????

This message is displayed upon successful initialization of the SAPI
scanner. The name and model of the scanner found will be displayed.


SAPI Error Messages
===================

	Manufacturer's device driver `HH$SCAN ' not found.

This message is displayed when the scanner driver cannot find the "helper"
driver (provided by the scanner maufacturer). The SAPI scanner
driver requires that this driver be loaded before it can load.


	Buffer size cannot be larger than 63k

This message is displayed when the argument to the /B parameter is greater
than 63.


	Watchdog timer value cannot be larger than 255

This message is displayed when the argument to the /W parameter is greater
than 255.


	Scanner not responding (do you have the right address?)

This message is displayed at initialization time if the scanner driver cannot
successfully communicate with the scanner.


	Error communicating with manufacturer's driver (????)

This message is displayed when an error occurs while sending or receiving
information from the manufacturer supplied driver. An error code is
included in the message to help identify the problem.


	Scanner hardware not configured for interrupts

The SAPI.EXE driver requires interrupts to function. The scanner
hardware interface must be configured to use interrupts. With most
manufacturer's drivers the interrupt can be set with a command line
parameter to the driver (e.g. /I=7, sets interrupt 7).
